;***************************************************************************
;
; File Name		:'beep.asm"
; Title			:"Beep" hangrszoro megjato
; Date			:2003.08.06.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034,  old: +36-30-9541-658 VFX
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:AVR
;
;***************************************************************************
;	D E S C R I P T I O N
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		------------------------------------
;	0.01	2003.08.06  VFX		Creation
;
;***************************************************************************
;Hardware
;***************************************************************************
;*
;*	SYSCLK: f=16.000 MHz (T= 62.5 ns)
;*
;***************************************************************************
;
;
;**************************************************************************
;* Hardware Def.
;

.equ	speakerPort = PORTB
.equ	speakerDir  = DDRB
.equ	speaker  = 7

.equ	BeepCLK = SYSCLK/8


;***************************************************************************
;**** VARIABLES
.DSEG

;***************************************************************************
.ESEG


;***************************************************************************
;**** CODE SEG
;***************************************************************************
.CSEG

Beep_Init:
		sbi	speakerPort,speaker
		sbi	speakerDir,speaker	;Beep output H speaker off

;************************************************************************
;**  Timer1 setup
;
		clr	R16
		sts	TCNT1H,R16
		sts	TCNT1L,R16		;Counter=0
		sts	TCCR1C,R16		;FOC1A FOC1B FOC1C - - - - -

		ldi	R16,0b00000100
		out	TCCR1A,R16		;COM1A1 COM1A0 COM1B1 COM1B0 COM1C1 COM1C0 WGM11 WGM10

		ldi	R16,0b00001000		;ICNC1 ICES1 - WGM13 WGM12 CS12 CS11 CS10
		out	TCCR1B,R16		;SYSCLK/8 == 2MHz

		lds	R16,ETIMSK	 	;- - TICIE3 OCIE3A OCIE3B TOIE3 OCIE3C OCIE1C
		andi	R16,0b11111110		
		sts	ETIMSK,R16

		ldi	R16,High(BeepCLK/800)
		sts	OCR1CH,R16
		out	OCR1AH,R16
		ldi	R16,Low(BeepCLK/800)
		sts	OCR1CL,R16
		out	OCR1AL,R16

		ret



Beep:		ldi	R16,20
		sts	SCNT3+0,R16
		clr	R16
		sts	SCNT3+1,R16
		ldi	R16,0b00001010		;ICNC1 ICES1 - WGM13 WGM12 CS12 CS11 CS10
		out	TCCR1B,R16
		CBI	LED0_PORT,LED0	;LED eg
		ret

