;***************************************************************************
;
; File Name		:'gsm.asm"
; Title			:DataLog GSM unit
; Date			:2003.06.08.	Lastmod.:[2003.06.08.]
; Version		:1.0.0
; Support telephone	:+36-70-333-4034,  Old: +36-30-9541-658 VFX
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:ATmaga128
;
;***************************************************************************
;	D E S C R I P T I O N
;
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who		why
;	----	----------  ---		--------------------------------------------
;	0.01	2003.06.08  VFX		Creation
;
;***************************************************************************
;
; GSM_Init
;
;
;Hardware
;***************************************************************************
;*


;**************************************************************************
;* Const Def

.equ	GSM_CMDTooLong = 0	;0. bit =1 CMD Too long

;***************************************************************************
.DSEG

.equ	GSM_Rx_Buffer_Length = 255

GSM_Rx_Head:	.byte 1
GSM_Rx_Tail:	.byte 1
GSM_Rx_Data:	.byte GSM_Rx_Buffer_Length+1

GSM_Flag:	.byte 1

;*************************************************************************
;*  C O D E
;*
.CSEG


;************************************************************************
;** GSM_Init
;** Set up the GSM Poert & Modem
;**
;************************************************************************
GSM_Init:	ldi	R16,0b00000001	;DTR low, Modem On
		sts	ADR_GSM,R16

		clr	R16
		sts	GSM_Rx_Tail,R16
		sts	GSM_Rx_Head,R16
		sts	GSM_Flag,R16
		ret




;************************************************************************
;** GSMTerminal
;** Communication with GSM Modem
;**
;************************************************************************

GSMTerminal:	call	Rs232GetByte0
		brcs	GSMTerm1
		ret

GSMTerm1:
		mov	R16,R0
		call	SendChrW
		rjmp	GSMTerminal



		lds	R16,GSM_Flag
		bst	R16,GSM_CMDTooLong
		mov	R16,R0
		brtc    GSM_Normal
GSM_Overrun:						;CMD head >= GSM_Rx_Buffer_Length ,only debug
		call	SendChrW
		rjmp	GSMTerminal

GSM_Normal:
		ldi	YL,low(GSM_Rx_Data)
		ldi	YH,high(GSM_Rx_Data)
		lds	XL,GSM_Rx_Head
		clr	XH
		cpi	R16,CR
		breq	GSM_Process
		cpi	XL,GSM_Rx_Buffer_Length
		brne	GSM_Norm1
GSM_TooLong:
		lds	R16,GSM_Flag
		sbr	R16,GSM_CMDTooLong
		sts	GSM_Flag,R16
		push	R0
GSM_Send1:	tst	XL
		breq	GSM_Send2
		dec	XL
SendGSMData:	push	XL
		ld	R16,Y+
		push	YL
		push	YH
		call	SendChrW
		pop	YH
		pop	YL
		pop	XL
		rjmp	GSM_Send1
GSM_Send2:	pop	R0
		rjmp	GSMTerm1
GSM_Norm1:
		clr	R16
		add	YL,XL
		adc	YH,R16
		st	Y,R0
		inc	XL
		sts	GSM_Rx_Head,XL
		rjmp	GSMTerminal

GSM_Process:
		lds	R16,GSM_Flag
		cbr	R16,GSM_CMDTooLong
		sts	GSM_Flag,R16
		rjmp	GSMTerminal


		add	YL,XL
		adc	YH,XH
		st	Y,R0
		ldi	YL,Low(CMD_Data)
		ldi	YH,High(CMD_Data)
		ldi	ZL,Low(GSMTm_Commands*2)
		ldi	ZH,High(GSMTm_Commands*2)	;Parancstablazat cime
		ldi	R16,(GSMTm_Commands/32768)	;Low/High part of FLASH
		out	RAMPZ,R16

GSMLeaderZero:	rcall	NextChar
		cpi	R16,LF
		breq	GSMLeaderZero			;Line feed is kimarad


GnextCMD:	elpm	R0,Z+
		tst	R0				;lehivjuk a tabla kovetkezo lelemet
		brne	GVanMegCMD	       		;ha 0, akkor nincs ilyen parancs
;		rjmp	CMDUnk		       		;ismeretlen parancs hibauzenet

GVanMegCMD:	ld	R16,X+		     		;parancs kovetkezo karaktere
		cp	R16,R0
		brne	GNemstimmel
		elpm	R0,Z+		     		;kovetkezo karakter a sztringben
		tst	R0
		brne	GVanMegCMD

						;PARANCS megvan!!!
		adiw	ZL,1			;tablaban a szoveg vegere ertunk
		andi	ZL,254			;tehat jo a parancs
		elpm	R0,Z+			;Z-t eltoljuk a vegrehajto rutin cimehez
		push	R0
		elpm
		push	R0			;STACKban vegrehajto rutin cime
		mov	ZL,XL
		mov	ZH,XH			;Z reg a parancs tobbi resze
		ret				;Ugras a vegrehajto reszre


GNemstimmel:	mov	XL,R4			;itt kell eldonteni miert nem stimmel
		mov	XH,R5			;pointer visszaallitasa

GSrchStr:	elpm	R0,Z+			;megkeressuk a sztring veget
		tst	R0
		brne	GSrchStr
		adiw	ZL,1
		andi	ZL,254			;csak a paros cim jo
		adiw	ZL,2			;kovetkezo sztring elejere allunk
;		rjmp	nextCMD


NextChar:
		ld	R16,Y+
		cpi	R16,32			;space kimarad
		breq	NextChar
		cpi	R16,HT
		breq	NextChar
		ret



GSMTm_Commands:

