;***************************************************************************
;
; File Name		:'user.asm"
; Title			:Altalanos felhasznaloi rutinok
; Date			:2001.12.30.	Lastmod.:[2003.02.08.]
; Version		:1.0.0
; Support telephone	:+36-30-9541-658 VFX
; Support fax		:+36-30-9809-372
; Support Email		:info@vfx.hu
; Target MCU		: ***
;
;***************************************************************************
;	D E S C R I P T I O N
;
;
;
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  why
;	----	----------  ---	--------------------------------------------
;	0.01	2001.12.30  VFX	Creation
;
;***************************************************************************
;
;
;
;Hardware
;***************************************************************************
;*



;**************************************************************************
;* Const Def





;***************************************************************************
.DSEG
UserFLASH:	.byte 3			;Belso FLASH irashoz kell, Data pointer to FLASH
AppData:	.byte 256		;atmeneti tarolo az update-hez
AppDataPointer:	.byte 1			;pointer az AppDatan beul

;*************************************************************************
;*  Text Const
;*
.CSEG


;********************************
; 8 byte-ot HEX alakban kiir a sorosportra X-regtol kezdve
; In:	X - address
;
;

HexDump:	ldi	R21,8
		clr	XL
		clr	XH
HexDump1:	call	DumpRow
		dec	R21
		brne	HexDump1
		ret



;****************************
;* Memoria DUMP 1 sora X-tol kezdve
;
DumpRow:	mov	R0,XH
		call	HexToUART		;Cim H-byte
		mov	R0,XL
		call	HexToUART		;L-byte
		rjmp	DumpCont


; R2:R1 Virtual Address, amit kiir a sor ele
DumpAddr:	mov	R0,R2
		call	HexToUART		;Cim H-byte
		mov	R0,R1
		call	HexToUART		;L-byte

DumpCont:
		ldi	R16,' '
		call	SendChrW
		push	XL
		push	XH
		call	DumpHalfRow
		ldi	R16,'|'
		call	SendChrW
		call	DumpHalfRow
		ldi	R16,' '
		call	SendChrW
		pop	XH
		pop	XL
		ldi	R22,16
DumpASCCIRow:	ld	R16,X+
		cpi	R16,32
		brcs	asciirossz
		cpi	R16,128
		brcs	asciijo
asciirossz:	ldi	R16,'.'			;igy jeloljuk a rossz ascii code-ot
asciijo:	call	SendChrW
		dec	R22
		brne	DumpASCCIRow
		ldi	R16,CR
		call	SendChrW
		ret

;********************************
; 8 byte-ot hex alakban kiir a sorosportra X-regtol kezdve
;
DumpHalfRow:	ldi	R22,8
DumpR0:		ld	R0,X+
		call	HexToUART
		ldi	R16,' '
		call	SendChrW
		dec	R22
		brne	DumpR0
		ret



TstHexDigit:	subi	R16,'0'
		brcs	tstherr
		cpi	R16,10
		brcs	tsthexok
		subi	R16,7
		brcs	tstherr
		cpi	R16,16
		brsh	tstherr
tsthexok:	clc
		ret
tstherr:	sec
		ret





.equ PAGESIZEB = PAGESIZE*2

;***********************************
; Felkeszules a FLASH irasara
;             					;ide majd kell meg az interruptok tiltasa stb...
INIT_Upgrade:
		clr	R0
		sts	UserFLASH+0,R0		;Ez a Z-reg
		sts	UserFLASH+1,R0
		sts	UserFLASH+2,R0		;Ez a RAMPZ
		sts	AppDataPointer,R0
		ret


;*********************************
; R16-nyi 0x1A -t kell tolteni a Flashbe
Usr_Fill_1A:
		clr	R1
		inc	R1
		rjmp	CopyAD0


;*********************************
;  R16 - hany byte-ot kell betolteni a FLASHbe X-regtol kezdve
;
CopyAppData:
		clr	R1			;ez donti el, hogy masolas vagy fill lesz-e
CopyAD0:	lds	R17,AppDataPointer
		ldi	ZL,Low(AppData)
		ldi	ZH,High(AppData)
		clr	R0
		add	ZL,R17
		adc	ZH,R0			;Z = AppData kovetkezo byte

CopyAD1:
		tst	R1
		breq	CopyVan
		ldi	R18,0x1A
		rjmp	FillVan
CopyVan:
		ld	R18,X+
FillVan:	st	Z+,R18
		inc	R17
		cpi	R17,0
		brne	CopyAD2
						     	;itt megtelt az AppData lehet FLASHbe tolni
		push	ZL
		push	ZH
		push	XL
		push	XH
		push	R17
		push	R16
		call	WriteToPage
		pop	R16
		pop	R17
		pop	XH
		pop	XL
		pop	ZH
		pop	ZL
		ldi	ZL,low(AppData)
		ldi	ZH,High(AppData)
		clr	R17

CopyAD2:	dec	R16
		brne	CopyAD1	   			;amig van masolando, addig ciklus
		sts	AppDataPointer,R17
		ret


WriteToPage:

		ldi	R16,128				;mert nem byte, hanem word kell
		ldi	XL,low(AppData)
		ldi	XH,High(AppData)


		lds	R18,UserFLASH+2
		out	RAMPZ,R18
		lds	ZH,UserFLASH+1
		lds	ZL,UserFLASH+0			;ahhol abbahagytuk az elobbi blokkot ott folytatjuk
							;[RAMPZ:Z] -> FLASH pointer

							;Disable write to Boot area
		cpi	R18,1
		brne	Wrloop
		cpi	ZH,0xE0				;[RAMPZ:Z]>=0xF000 (word)
		brlo	Wrloop

		ret					;if this is boot -> exit

Wrloop:
		ld	R0,X+
		ld	R1,X+
		ldi	R17,0b00000001			;Fill Temp buffer Command
		call	Do_spm
		adiw	ZL,2
		cpi	ZL,0				;Ha ZL=0, akkor laphatarhoz ertunk, irni kell a flashbe
		brne	MegNemKellIrni

		rcall	WriteToFLASH

MegNemKellIrni:
		dec	R16
		brne	Wrloop
		sts	UserFLASH+0,ZL			;ahhol abbahagytuk az elobbi blokkot ott folytatjuk
		sts	UserFLASH+1,ZH
		sts	UserFLASH+2,R18
		ret

WriteToFLASH:						;mikor ide jut eggyel nagyobb lapon vagyunk
		push	ZH
		dec	ZH				;most vagyunk a jo lapon
							;lehet torolni
		ldi	R17,0b00000011			;Erase parancs
		rcall	Do_spm

		ldi	R17,0b00000101			;Write Page Command
		rcall	Do_spm
       							;itt kellene visszaellleorizni az uj flash tartalmat!!!

		ldi	R17, (1<<RWWSRE) | (1<<SPMEN)	;ReEnable RWW Section
		call	Do_spm
Return:
		lds	R19,SPMCSR
		sbrs	R19,RWWSB			; If RWWSB is set, the RWW section is not ready yet
		 rjmp	RWWEnabled
		rjmp	Return

RWWEnabled:	pop	ZH
		cpi	ZH,0
		brne	OkVege
		inc	R18
		out	RAMPZ,R18			;Ha Z==0, akkor atleptuk a 64kb hatart, bankot kell valtani
OkVege:
		ret

;******************************************************
; R17-ben a SPM parancs
;
Do_spm:
Wait_spm:
		lds	R19,SPMCSR			; check for previous SPM complete
		sbrc	R19,SPMEN
		 rjmp	Wait_spm
							; input: spmcsrval determines SPM action
							; disable interrupts if enabled, store status
		in	R3,SREG
		cli
Wait_ee:						; check that no EEPROM write access is present
		sbic	EECR,EEWE
		 rjmp	Wait_ee
							; SPM timed sequence
		sts	SPMCSR,R17
		spm
							; restore SREG (to enable interrupts if originally enabled)
		out	SREG,R3
		ret


;****************************************
;R0-ban levo BCD byte konvertalasa R1:R0-ba
;
BCDToASCII:	push	R16
		mov	R16,R0
		swap	R16
		andi	R16,0x0F
		ori	R16,48		;itt ascii '0'...'9' a digittol fuggoen
		mov	R1,R16
		mov	R16,R0
		andi	R16,0x0F
		ori	R16,48
		mov	R0,R16
		pop	R16
		ret



;****************************************
;R0-ban levo byte kiirasa az UARTra (HEX)
;
HexToUART:	LDI	R17,48
		LDI	R18,7
		MOV	R16,R0
		ANDI	R16,0x0F
		CPI	R16,10
		BRCS	Kicsi0x
		ADD	R16,R18
Kicsi0x:	ADD	R16,R17
		push	R16			;alsobyte utolsonak megy ki

		MOV	R16,R0
		SWAP	R16
		ANDI	R16,0x0F
		CPI	R16,10
		BRCS	Kicsi1
		ADD	R16,R18
Kicsi1:		ADD	R16,R17
		call	SendChrW		;folso byte megy elosszor
		pop	R16
		call	SendChrW		;aztan az also
		clc				;nincs hiba
		ret



;**************************************
;** [Z] buffer tartalmat a sosorportra kuldi, 0 a lezaras
;**
SendBuff:	ld	R0,Z+
		or	R0,R0
		breq	SendASCOk
		push	ZL
		push	ZH
		call	SendChr
		pop	ZH
		pop	ZL
		rjmp	SendBuff
SendASCOk:	ret


;********************************
; R22 byte-nyi adatot ir ki a sorosportra X-regtol kezdve
; In:	X - address
; 	R22 - byte count
;
;
DumpASCII:	ld	R16,X+
		push	R22
		call	SendChrW
		pop	R22
		dec	R22
		brne	DumpASCII
		ret


;********************************
; Adatot ir ki a sorosportra X-regtol kezdve
; In:	X - address
;
PrintASCII:	ld	R16,X+
		cpi	R16,0
		breq	PrintASCII1
		call	SendChrW
		jmp	PrintASCII
PrintASCII1:	ret


;****************************************
;R0-ban levo byte kiirasa az UARTra (BIN)
;
BinToUART:	ldi	R18,8
BTU:		clr	R16
		rol	R0
		rol	R16
		ori	R16,48		;itt ascii '0' vagy '1' a bittol fuggoen
		push	R0
		push	R18
		call	SendChrW
		pop	R18
		pop	R0
		dec	R18
		brne	BTU
		ret

;****************************************
;R0-ban levo byte kiirasa az UARTra (BCD)
;
BCDToUART:	mov	R16,R0
		push	R0
		swap	R16
		andi	R16,0x0F
		ori	R16,48		;itt ascii '0'...'9' a digittol fuggoen
		call	SendChrW
		pop	R16
		andi	R16,0x0F
		ori	R16,48
		call	SendChrW
		ret

